.386

.MODEL FLAT,STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

DlgProc PROTO :DWORD, :DWORD, :DWORD, :DWORD

.DATA

DlgName    DB "MyDialog",0
AppName    DB "Nasze drugie okno dialogowe",0
TestString DB "Och! Jestem w edytorze",0

.DATA?

hInstance   HINSTANCE ?
CommandLine LPSTR     ?
buffer      DB 512 DUP(?)

.CONST

IDC_EDIT     EQU  3000
IDC_BUTTON   EQU  3001
IDC_EXIT     EQU  3002
IDM_GETTEXT  EQU 32000
IDM_CLEAR    EQU 32001
IDM_EXIT     EQU 32002


.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE DialogBoxParam, hInstance,\
                           ADDR DlgName, NULL, ADDR DlgProc, NULL
    INVOKE ExitProcess, eax

DlgProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_INITDIALOG
        INVOKE GetDlgItem, hWnd, IDC_EDIT
        INVOKE SetFocus, eax
    .ELSEIF uMsg==WM_CLOSE
        INVOKE SendMessage, hWnd, WM_COMMAND, IDM_EXIT, 0
    .ELSEIF uMsg==WM_COMMAND
        mov eax, wParam
        .IF lParam==0
            .IF ax==IDM_GETTEXT
                INVOKE GetDlgItemText, hWnd, IDC_EDIT, ADDR buffer, 512
                INVOKE MessageBox, NULL, ADDR buffer, ADDR AppName, MB_OK
            .ELSEIF ax==IDM_CLEAR
                INVOKE SetDlgItemText, hWnd, IDC_EDIT, NULL
            .ELSEIF ax==IDM_EXIT
                INVOKE EndDialog, hWnd, NULL
            .ENDIF
        .ELSE
            mov dx, WORD PTR wParam + 2
            .IF dx==BN_CLICKED
                .IF ax==IDC_BUTTON
                    INVOKE SetDlgItemText, hWnd, IDC_EDIT, ADDR TestString
                .ELSEIF ax==IDC_EXIT
                    INVOKE SendMessage, hWnd, WM_COMMAND, IDM_EXIT, 0
                .ENDIF
            .ENDIF
        .ENDIF
    .ELSE
        mov eax, FALSE
        ret
    .ENDIF
    mov eax, TRUE
    ret
	
DlgProc ENDP

END start
